<?php
/*
Plugin Name: DY Breadcrumbs
Description: Adds breadcrumb navigation to website
Version: 1.3
Author: Dmitry Yakovlev
Author URI: http://dimayakovlev.ru/
*/

# get correct id for plugin
$thisfile = basename(__FILE__, ".php");
define('DY_BREADCRUMBS', $thisfile);

i18n_merge(DY_BREADCRUMBS) || i18n_merge(DY_BREADCRUMBS, 'en_US');

# register plugin
register_plugin(
  $thisfile,                          # ID of plugin, should be filename minus php
  'DY Breadcrumbs',                   # Title of plugin
  '1.3',                              # Version of plugin
  'Dmitry Yakovlev',                  # Author of plugin
  'http://dimayakovlev.ru/',          # Author URL
  i18n_r(DY_BREADCRUMBS . '/DY_BREADCRUMBS_PLUGIN_DESCRIPTION'),   # Plugin Description
  '',                                 # Page type of plugin
  ''                                  # Function that displays content
);

function dyGetBreadcrumbs($slug, $home = true, $homeTitle = false, $parentTitleLength = 0, $currentTitleLength = 0, $fullPath = false) {
  global $pagesArray;
  $slug = (string)$slug;
  $tmpSlug = $slug;
  if (isset($pagesArray[$slug])) {
    if ($home) {
      if (!$homeTitle) $homeTitle = dyGetDefaultHomeTitle();
      if ($slug == 'index') {
        echo '<li class="current active">' . $homeTitle . '</li>';
      } else {
        echo '<li><a href="' . find_url('index', ''). '">' . $homeTitle . '</a></li>';
      }
    }
    while ($pagesArray[$tmpSlug]['parent']) {
      $tmpSlug = $pagesArray[$tmpSlug]['parent'];
      if (!$pagesArray[$tmpSlug]['private'])
        $result[] = $tmpSlug;
    }
    if (isset($result)) {
      $parent = '';
      foreach (array_reverse($result) as $item) {
        $title = $pagesArray[$item]['title'];
        if ($parentTitleLength > 0 && mb_strlen(html_entity_decode($title), 'UTF-8') > $parentTitleLength + 3) {
          $title = mb_substr(html_entity_decode($title), 0, $parentTitleLength) . '&hellip;';
        }
        echo '<li><a href="' . find_url($item, $parent) . '">' . $title . '</a></li>';
        if ($fullPath) {
          $parent .= $item . '/';
        } else {
          $parent = $item;
        }
      }
    }
    if ($slug != 'index') {
      $title = $pagesArray[$slug]['title'];
      if ($currentTitleLength > 0 && mb_strlen(html_entity_decode($title), 'UTF-8') > $currentTitleLength + 3) {
        $title = mb_substr(html_entity_decode($title), 0, $currentTitleLength) . '&hellip;';
      }
      echo '<li class="current active">' . $title . '</li>';
    }
  }
}

function dyGetDefaultHomeTitle() {
  return i18n_r(DY_BREADCRUMBS . '/DY_BREADCRUMBS_HOME');
}
?>